/*
 * $Id: main.cpp 82 2008-05-01 16:48:45Z rosiere $
 *
 * [ Description ]
 * 
 */

#include "Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/SelfTest/include/test.h"

#define NB_PARAMS 4

void usage (int argc, char * argv[])
{
  err (_("<Usage> %s name_instance list_params.\n"),argv[0]);
  err (_("list_params is :\n"));
  err (_(" * nb_context                        (uint32_t)\n"));
  err (_(" * nb_inst_decod                     (uint32_t)\n"));
  err (_(" * size_queue                        (uint32_t)\n"));
  err (_(" * size_general_data                 (uint32_t)\n"));
  err (_(" * nb_branch_speculated [nb_context] (uint32_t)\n"));

  exit (1);
}

#ifndef SYSTEMC
int main    (int argc, char * argv[])
#else
int sc_main (int argc, char * argv[])
#endif
{
  if (argc < static_cast<int>(2+NB_PARAMS))
    usage (argc, argv);

  uint32_t x = 1;

  string name = argv[x++];
  uint32_t _nb_context        = fromString<uint32_t>(argv[x++]);
  uint32_t _nb_inst_decod     = fromString<uint32_t>(argv[x++]);
  uint32_t _size_queue        = fromString<uint32_t>(argv[x++]);
  uint32_t _size_general_data = fromString<uint32_t>(argv[x++]);

  if (argc != static_cast<int>(2+NB_PARAMS+_nb_context))
    usage (argc, argv);

  uint32_t * _nb_branch_speculated = new uint32_t [_nb_context];
  for (uint32_t i=0; i<_nb_context; i++)
    _nb_branch_speculated [i] = fromString<uint32_t>(argv[x++]);

  int _return = EXIT_SUCCESS;
  try 
    {
      morpheo::behavioural::core::multi_front_end::front_end::decod_unit::decod_queue::Parameters * param = new morpheo::behavioural::core::multi_front_end::front_end::decod_unit::decod_queue::Parameters
	(_nb_context       ,
	 _nb_inst_decod    ,
	 _size_queue       ,
	 _size_general_data,
	 _nb_branch_speculated);
      
      msg(_("%s"),param->print(1).c_str());
      
      test (name,param);
    }
  catch (morpheo::ErrorMorpheo & error)
    {
      msg (_("<%s> :\n%s"),name.c_str(), error.what ());
      _return = EXIT_FAILURE;
    }
  catch (...)
    {
      err (_("<%s> : This test must generate a error.\n"),name.c_str());
      _return = EXIT_FAILURE;
    }

  delete [] _nb_branch_speculated;

  return (_return);
}
